#include "mbed.h"

Serial serial(SERIAL_TX, SERIAL_RX);

DigitalOut myled(LED1);

Ticker ticker;
int blink = 0;

void tick()
{
    blink = !blink;
    myled = !myled;
}

int main()
{
    serial.baud(115200);
    for (int i = 0; i < 5*2; ++i) { // 5x zablikání LED s periodou 50 ms
        myled = !myled;
        wait(0.05);
    }
    myled = 0;
    while(serial.readable()) { // flush the input buffer
        serial.getc();
    }
    float periods[] = { 0.05, 0.1, 0.2, 0.5, 1.0 };
    serial.putc('i');
    while (1) {
        while(!serial.readable()) {
            //aktivní čekání na přijetí bytu
        }
        int c = serial.getc();
        int ok = 1;
        switch(c) {
            case 's':
                myled = 1;
                ticker.detach();
                break;
            case 'e':
                myled = 0;
                ticker.detach();
                break;
            default:
                if (c >= '1' && c <= '5') {
                    ticker.attach(tick, periods[c-'1']);
                } else {
                    ok = 0;
                }
                break;
        }
        while (!serial.writeable()) {}
        serial.putc(ok ? 'a' : 'f');
    }
}

