#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>

#include "prg_serial.h"

int main(int argc, char *argv[])
{
   int ret = 0;
   const char *serial = argc > 1 ? argv[1] : "/dev/cuaU0";
   fprintf(stderr, "INFO: open serial port at %s\n", serial);
   int fd = serial_open(serial);
   if (fd != -1) { // read from serial port
      _Bool quit = false;
      while (!quit) {
	 int c = getchar();
	 _Bool write_read_response = false;
	 switch (c) {
	    case 'q':
	       printf("Quit the program");
	       quit = true;
	       break;
	    case 's':
	       printf("Send 's' - LED on\n");
	       write_read_response = true;
	       break;
	    case 'e':
	       printf("Send 'e' - LED off\n");
	       write_read_response = true;
	       break;
	    default: //nothing to do
	       break;
	 } // end switch c
	 if (write_read_response) {
	    int r = serial_putc(fd, c);
	    if (r != -1) {
	       fprintf(stderr, "DEBUG: Received response '%c'\n", r);
	    } else {
	       fprintf(stderr, "ERROR: Error in received responses\n");
	    }
	 }
      } // end while()
      serial_close(fd);
   } else {
      fprintf(stderr, "ERROR: Cannot open device %s\n", serial);
   }
   return ret;
}
